summaryrefslogtreecommitdiff
path: root/RC9/qpid/cpp/src/tests/start_cluster
diff options
context:
space:
mode:
Diffstat (limited to 'RC9/qpid/cpp/src/tests/start_cluster')
-rwxr-xr-xRC9/qpid/cpp/src/tests/start_cluster46
1 files changed, 46 insertions, 0 deletions
diff --git a/RC9/qpid/cpp/src/tests/start_cluster b/RC9/qpid/cpp/src/tests/start_cluster
new file mode 100755
index 0000000000..ee306edf14
--- /dev/null
+++ b/RC9/qpid/cpp/src/tests/start_cluster
@@ -0,0 +1,46 @@
+#!/bin/sh
+
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+
+# Start a cluster of brokers on local host, put the list of ports for cluster members in cluster.ports
+#
+
+# Execute command with the ais group set.
+with_ais_group() {
+ id -nG | grep '\<ais\>' >/dev/null || { echo "You are not a member of the ais group." 1>&2; exit 1; }
+ echo $* | newgrp ais
+}
+
+test -f cluster.ports && { echo "cluster.ports file already exists" ; exit 1; }
+rm -f cluster*.log
+SIZE=$1; shift
+CLUSTER=`pwd` # Cluster name=pwd, avoid clashes.
+OPTS="-d --load-module ../.libs/cluster.so --cluster-name=$CLUSTER --no-data-dir --auth=no $*"
+
+if test "$SIZE" = "one"; then # Special case of singleton cluster, use default port.
+ ../qpidd -q
+ with_ais_group ../qpidd $OPTS --log-to-file=cluster.log || exit 1
+else
+ for (( i=0; i<SIZE; ++i )); do
+ PORT=`with_ais_group ../qpidd -p0 --log-to-file=cluster$i.log $OPTS` || exit 1
+ echo $PORT >> cluster.ports
+ done
+fi
+